<template>
  <div class="breed">
    <div class="container">
      <control-panel>
      </control-panel>
      <div class="dogs__list">
        <card :src="item.src" :name="item.name" v-for="(item, index) in getDogs" :key="index" />
      </div>
      <Observer @intersect="intersected"/>
    </div>
    <to-top />
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import Card from '../components/Card'
import Observer from '../components/Observer'
import ToTop from '../components/ToTop'
import ControlPanel from '../components/ControlPanel'
// @ is an alias to /src

export default {
  name: 'Breed',
  props: ['slug'],
  components: {
    Card,
    Observer,
    ToTop,
    ControlPanel
  },
  data () {
    return {
      sortBy: 'RANDOM',
      page: 1
    }
  },
  computed: {
    ...mapGetters(['getDogs'])
  },
  methods: {
    ...mapActions(['fetchDogs']),
    intersected () {
      this.fetchDogs({ breed: this.slug })
    }
  },
  created () {
    this.fetchDogs({ breed: this.slug })
  },
  beforeDestroy () {
    this.$store.commit('CLEAR_DOGS')
  },
  async beforeRouteUpdate (to, from, next) {
    this.$store.commit('CLEAR_DOGS')
    await this.fetchDogs({ breed: to.params.slug })
    next()
  }
}
</script>

<style lang="scss">
$card-with: 367px;
.dogs__list {
  display: grid;
  grid-gap: 30px;
  grid-template-columns: $card-with $card-with $card-with;
}
</style>
